<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class QrCodeFactory
{

    use TQuery;
    protected $entityManager;
    protected $connection;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
    }

    public function buscaTarefasPorOperador($params)
    {
        $sql = "SELECT NRHIERARQUIAFUNC
                FROM FCM_HIERARQUIAFUNC
                WHERE IDATIVO = '$params[0]'";
        
        $resultado =  $this->connection->executeQuery($sql)->fetchAllAssociative();
        
        $nr = $resultado[0]['NRHIERARQUIAFUNC'];

        $sql = "SELECT A.NRFUNCIONARIOSHIERARQ, A.CDOPERADOR, A.CDOPERADORPAI, 
                        B.NMOPERADOR, H.NMHIERARQUIAFUNC
                    FROM FCM_FUNCIONARIOSHIERARQ A
                    JOIN OPERADOR B 
                    ON B.CDOPERADOR = A.CDOPERADOR
                    JOIN FCM_HIERARQUIAFUNC H 
                    ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                WHERE A.NRHIERARQUIAFUNC = '$nr'";

        $retorno = $this->connection->executeQuery($sql)->fetchAllAssociative();

        return $retorno;
    }

    public function findVistoria($param, $filtro)
    {
        $sql =  "SELECT VIST.NMGERENCIAMENTOCHK, VIST.DTHORAAGEND, VIST.DTHRFINALAGEND, 
                        VIST.NRLOCALCLIENTE, OPERADOR.NMOPERADOR, VIST.NRGERENCIAMENTOCHK,
                        LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI, LCP.NMLOCALCLIENTE AS NMLOCALPAI,
                        VIST.IDSITUACAOGERCHK
                   FROM FCM_GERENCIAMENTOCHK VIST
                   JOIN OPERADOR 
                     ON OPERADOR.CDOPERADOR = VIST.CDOPERADOR
                   JOIN FCM_LOCALCLI LC
                     ON LC.NRLOCALCLIENTE = VIST.NRLOCALCLIENTE
                   JOIN FCM_LOCALCLI LCP
                     ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                   JOIN FCM_CHECKLISTAGEND CA
                     ON CA.NRCHECKLISTAGEND = VIST.NRCHECKLISTAGEND
                  WHERE VIST.CDOPERADOR = {$param['CDOPERADOR']}
                    AND VIST.NRLOCALCLIENTE = {$param['NRLOCALCLIENTE']}
                    AND VIST.IDSITUACAOGERCHK IN (1,2)
                    AND VIST.IDATIVO = 'S' " . $filtro . "";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function findTarefa($param, $filtro)
    {

        $sql =  "SELECT TAREF.NMCHECKLISTAGEND, TAREF.DTHORAAGEND, TAREF.DTHRFINALAGEND, 
                        TAREF.NRLOCALCLIENTE, OPERADOR.NMOPERADOR, FCM_LOCALCLI.NMLOCALCLIENTE,
                        TAREF.NRCHECKLISTAGEND, TO_CHAR(TAREF.DTHORAAGEND, 'DD/MM HH24:MI') AS DATAHORA,
                        CASE TAREF.IDSITUACAOAGEND WHEN '1' THEN 'Pendente'
                            WHEN '2' THEN 'Em andamento'
                            WHEN '3' THEN 'Cancelado'
                            WHEN '4' THEN 'Concluído'
                            WHEN '5' THEN 'Atrasado'
                            ELSE NULL END AS IDSITUACAOAGEND
                    FROM FCM_CHECKLISTAGEND TAREF
                    JOIN OPERADOR
                    ON TAREF.CDOPERADOR = OPERADOR.CDOPERADOR
                    JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.NRLOCALCLIENTE = TAREF.NRLOCALCLIENTE
                    WHERE TAREF.CDOPERADOR = {$param['CDOPERADOR']}
                    AND TAREF.NRLOCALCLIENTE = {$param['NRLOCALCLIENTE']}
                    AND TAREF.IDSITUACAOAGEND IN (1,2)
                    AND TAREF.IDATIVO = 'S' " . $filtro . "";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }
}
