import { ITekConfig } from '@zeedhi/teknisa-components-common';
import prodEnvironment from './prodEnvironment.json';
import devEnvironment from './devEnvironment.json';

const env = process.env.NODE_ENV === 'production' ? prodEnvironment : devEnvironment;

const config: ITekConfig = {
  endPoint: env.endPoint,
  metadataEndPoint: env.metadataEndPoint,
  datasourceArrayFormat: 'brackets',
  env: {
    product: env.product,
    baseUrl: env.baseUrl,
    modules: env.modules,
    endPoint: env.endPoint,
    loginRoutePath: env.modules.login.routePath,
    loginBackgroundImgUrl: env.modules.login.backgroundImgUrl,
    loginEndPoint: env.modules.login.endPoint,
  },
  saveGridLayoutsEndPoint: env.saveGridLayoutsEndPoint,
  loadGridLayoutsEndPoint: env.loadGridLayoutsEndPoint,
};

export default config;
